--코드 5-42 SELECT문
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , A.INDUTY_CL_SE_CD
     , A.UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL A
;

--코드 5-43 SELECT문 - WHERE절 사용
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , A.INDUTY_CL_SE_CD
     , A.UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL A
 WHERE INDUTY_CL_NM LIKE '%커피%'
;

--코드 5-44 = 연산자의 사용
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '서울역'
;

--코드 5-45 지하철역승하차 조회
SELECT A.SUBWAY_STATN_NO
     , A.STD_YM
     , A.BEGIN_TIME
     , A.END_TIME
     , A.TK_GFF_SE_CD
     , A.TK_GFF_CNT
  FROM TB_SUBWAY_STATN_TK_GFF A
 WHERE A.SUBWAY_STATN_NO = '000032' --2호선 강남
   AND A.STD_YM = '202010' --2020년 10월
   AND A.BEGIN_TIME LIKE '18%'
   AND A.END_TIME LIKE '19%'
   AND A.TK_GFF_SE_CD IN ('TGS001', 'TGS002') --TGS001:승차, TGS002:하차
;

--코드 5-46 IS NULL 연산자
SELECT A.ADRES_CL_CD
     , A.ADRES_CL_NM
     , A.ADRES_CL_SE_CD
     , NVL(A.UPPER_ADRES_CL_CD, '(Null)') UPPER_ADRES_CL_CD
  FROM TB_ADRES_CL A
 WHERE A.UPPER_ADRES_CL_CD IS NULL
;

--코드 5-47 IS NOT NULL 연산자
SELECT A.ADRES_CL_CD
     , A.ADRES_CL_NM
     , A.ADRES_CL_SE_CD
     , NVL(A.UPPER_ADRES_CL_CD, '(Null)') UPPER_ADRES_CL_CD
  FROM TB_ADRES_CL A
 WHERE A.UPPER_ADRES_CL_CD IS NOT NULL
;

--코드 5-48 논리 연산자의 사용
SELECT A.BSSH_NO
     , A.CMPNM_NM
     , A.LNM_ADRES
  FROM TB_BSSH A
 WHERE A.LNM_ADRES LIKE '서울%'
   AND
      (   A.CMPNM_NM LIKE '%스타벅스%'
       OR A.CMPNM_NM LIKE '%이디야%'
       OR A.CMPNM_NM LIKE '%파스쿠찌%'
      )
   AND NOT A.LNM_ADRES LIKE '%강남구%'
;

--코드 5-49 부정 비교 연산자의 사용
SELECT A.SUBWAY_STATN_NO
     , A.STD_YM
     , A.BEGIN_TIME
     , A.END_TIME
     , CASE WHEN A.TK_GFF_SE_CD = 'TGS001' THEN '승차'
            WHEN A.TK_GFF_SE_CD = 'TGS002' THEN '하차'
             END AS 승하차구분
     , A.TK_GFF_CNT
  FROM TB_SUBWAY_STATN_TK_GFF A
 WHERE A.SUBWAY_STATN_NO = '000032' --2호선 강남
   AND A.STD_YM = '202010'
   AND A.TK_GFF_SE_CD IN ('TGS001', 'TGS002') --승차, 하차
   AND NOT A.TK_GFF_CNT < 100000
;

--코드 5-50 부정 SQL 연산자의 사용
SELECT A.SUBWAY_STATN_NO
     , A.STD_YM
     , A.BEGIN_TIME
     , A.END_TIME
     , CASE WHEN A.TK_GFF_SE_CD = 'TGS001' THEN '승차'
            WHEN A.TK_GFF_SE_CD = 'TGS002' THEN '하차'
             END AS 승하차구분
     , A.TK_GFF_CNT
  FROM TB_SUBWAY_STATN_TK_GFF A
 WHERE A.SUBWAY_STATN_NO = '000032' --2호선 강남
   AND A.STD_YM = '202010'
   AND A.TK_GFF_SE_CD NOT IN ('TGS001') --승차는 포함하지 않음
   AND A.TK_GFF_CNT NOT BETWEEN 0 AND 99999 --0~99999 사이가 아닌 것
;

--코드 5-51 테스트용 테이블 생성
CREATE TABLE TB_CHAR
(
  CHAR_NO CHAR(4)
, CHAR_4 CHAR(4)
, CHAR_5 CHAR(5)
, CONSTRAINT PK_TB_CHAR PRIMARY KEY (CHAR_NO)
)
;

--코드 5-52 테스트용 데이터 입력
INSERT INTO TB_CHAR (CHAR_NO, CHAR_4, CHAR_5) VALUES ('1001', 'SQLD', 'SQLD');
INSERT INTO TB_CHAR (CHAR_NO, CHAR_4, CHAR_5) VALUES ('1002', 'SQLD', 'SQLP');

COMMIT;


--코드 5-53 데이터 조회
SELECT REPLACE(CHAR_4, ' ', '_') AS CHAR_4 --공백이 있는 경우 '_'로 치환
     , REPLACE(CHAR_5, ' ', '_') AS CHAR_5 --공백이 있는 경우 '_'로 치환
  FROM TB_CHAR
;

--코드 5-54 CHAR 데이터형 간 비교 - "=" 연산자
SELECT CHAR_NO
     , REPLACE(CHAR_4, ' ', '_') AS CHAR_4 --공백이 있는 경우 '_'로 치환
     , REPLACE(CHAR_5, ' ', '_') AS CHAR_5 --공백이 있는 경우 '_'로 치환
  FROM TB_CHAR
 WHERE CHAR_4 = 'SQLD'
   AND CHAR_4 = CHAR_5
;

--코드 5-55 CHAR 데이터형 간 비교 - "＜" 연산자
SELECT CHAR_NO
     , REPLACE(CHAR_4, ' ', '_') AS CHAR_4 --공백이 있는 경우 '_'로 치환
     , REPLACE(CHAR_5, ' ', '_') AS CHAR_5 --공백이 있는 경우 '_'로 치환
  FROM TB_CHAR
 WHERE CHAR_NO = '1002'
   AND CHAR_4 < CHAR_5
;

--코드 5-56 테스트용 테이블 생성
CREATE TABLE TB_VARCHAR2
(
  VARCHAR_NO CHAR(4)
, CHAR_4 CHAR(4)
, VARCHAR2_5 VARCHAR2(5)
, CONSTRAINT PK_TB_VARCHAR2 PRIMARY KEY (VARCHAR_NO)
)
;

--코드 5-57 테스트용 데이터 입력
INSERT INTO TB_VARCHAR2(VARCHAR_NO, CHAR_4, VARCHAR2_5) VALUES ('1001', 'SQLD', 'SQLD ');
INSERT INTO TB_VARCHAR2(VARCHAR_NO, CHAR_4, VARCHAR2_5) VALUES ('1002', 'SQLD', 'SQLP ');

COMMIT;

--코드 5-58 데이터 조회
SELECT REPLACE(CHAR_4, ' ', '_') AS CHAR_4 --공백이 있는 경우 '_'로 치환
     , REPLACE(VARCHAR2_5, ' ', '_') AS VARCHAR_5 --공백이 있는 경우 '_'로 치환
  FROM TB_VARCHAR2
;

--코드 5-59 CHAR 타입과 VARCHAR2 타입의 비교
SELECT REPLACE(CHAR_4, ' ', '_') AS CHAR_4
     , REPLACE(VARCHAR2_5, ' ', '_') AS VARCHAR2_5
  FROM TB_VARCHAR2
 WHERE VARCHAR_NO = '1001'
   AND CHAR_4 = VARCHAR2_5
;

--코드 5-60 VARCHAR2 타입에 TRIM함수 사용
SELECT REPLACE(CHAR_4, ' ', '_') AS CHAR_4
     , REPLACE(VARCHAR2_5, ' ', '_') AS VARCHAR2_5
  FROM TB_VARCHAR2
 WHERE VARCHAR_NO = '1001'
   AND CHAR_4 = TRIM(VARCHAR2_5) --TRIM 함수로 VARCHAR2_5 뒤에 공백을 삭제
;

--코드 5-61 CHAR 타입과 상수 값 비교
SELECT REPLACE(CHAR_4, ' ', '_') AS CHAR_4
     , REPLACE(VARCHAR2_5, ' ', '_') AS VARCHAR2_5
  FROM TB_VARCHAR2
 WHERE VARCHAR_NO = '1001'
   AND CHAR_4 = 'SQLD '
;

--코드 5-62 VARCHAR2 타입과 상수 값 비교
SELECT REPLACE(CHAR_4, ' ', '_') AS CHAR_4
     , REPLACE(VARCHAR2_5, ' ', '_') AS VARCHAR2_5
  FROM TB_VARCHAR2
 WHERE VARCHAR_NO = '1001'
   AND VARCHAR2_5 = 'SQLD'
;

--코드 5-63 WHERE절에 ROWNUM 이용
SELECT ROWNUM AS RNUM
     , A.BSSH_NO
     , A.CMPNM_NM
     , NVL(A.BHF_NM, '(Null)') AS BHF_NM
     , A.LNM_ADRES
  FROM TB_BSSH A
 WHERE ROWNUM <= 10
;

