--코드 5-67 집계 함수 사용 예시
SELECT COUNT(*) AS "전체상가수"
     , MAX(LO) AS "최대경도"
     , MIN(LO) AS "최소경도"
     , MAX(LA) AS "최대위도"
     , MIN(LA) AS "최소위도"
  FROM TB_BSSH
;

--코드 5-68 공집합 리턴
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '평양역'
;

--코드 5-69 MAX 함수를 이용한 공집합 정보 출력
SELECT NVL(MAX(A.SUBWAY_STATN_NO), '지하철역없음') AS SUBWAY_NO
     , NVL(MAX(A.LN_NM), '노선명없음') AS LN_NM
     , NVL(MAX(A.STATN_NM), '역명없음') AS STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM = '평양역'
;

--코드 5-70 GROUP BY절의 사용
SELECT A.POPLTN_SE_CD
     , SUM(A.POPLTN_CNT) "인구수합계"
  FROM TB_POPLTN A
 WHERE A.STD_YM = '202010'
GROUP BY A.POPLTN_SE_CD
;

--코드 5-71 HAVING절의 사용
SELECT A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , SUM(A.POPLTN_CNT) AS "인구수합계"
  FROM TB_POPLTN A
 WHERE A.STD_YM = '202010'
GROUP BY A.POPLTN_SE_CD, A.AGRDE_SE_CD
HAVING SUM(A.POPLTN_CNT) < 1000000
;

--코드 5-72 CASE WHEN문을 사용
SELECT A.SUBWAY_STATN_NO
     , SUM(CASE WHEN A.TK_GFF_SE_CD = 'TGS001'
                THEN A.TK_GFF_CNT ELSE 0 END) AS "승차인원수합계"
     , SUM(CASE WHEN A.TK_GFF_SE_CD = 'TGS002'
                THEN A.TK_GFF_CNT ELSE 0 END) AS "하차인원수합계"
     , SUM(CASE WHEN A.BEGIN_TIME = '0800' AND A.END_TIME = '0900' AND A.TK_GFF_SE_CD = 'TGS001'
                THEN A.TK_GFF_CNT ELSE 0 END) AS "출근시간대승차인원수합계"
     , SUM(CASE WHEN A.BEGIN_TIME = '0800' AND A.END_TIME = '0900' AND A.TK_GFF_SE_CD = 'TGS002'
                THEN A.TK_GFF_CNT ELSE 0 END) AS "출근시간대하차인원수합계"
     , SUM(CASE WHEN A.BEGIN_TIME = '1800' AND A.END_TIME = '1900' AND A.TK_GFF_SE_CD = 'TGS001'
                THEN A.TK_GFF_CNT ELSE 0 END) AS "퇴근시간대승차인원수합계"
     , SUM(CASE WHEN A.BEGIN_TIME = '1800' AND A.END_TIME = '1900' AND A.TK_GFF_SE_CD = 'TGS002'
                THEN A.TK_GFF_CNT ELSE 0 END) AS "퇴근시간대하차인원수합계"
     , SUM(TK_GFF_CNT) AS "승하차인원수합계"
  FROM TB_SUBWAY_STATN_TK_GFF A
 WHERE A.STD_YM = '202010'
GROUP BY A.SUBWAY_STATN_NO
HAVING SUM(CASE WHEN A.TK_GFF_SE_CD = 'TGS001' --승차인원수
                THEN A.TK_GFF_CNT ELSE 0 END) >= 1000000
    OR SUM(CASE WHEN A.TK_GFF_SE_CD = 'TGS002' --하차인원수
                THEN A.TK_GFF_CNT ELSE 0 END) >= 1000000
;

--코드 5-73 지하철 테이블 조회
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.SUBWAY_STATN_NO = '000040'
;

--코드 5-74 테스트 테이블 생성
CREATE TABLE TB_AGG_NULL_TEST
(
   NUM NUMBER(15, 2)
);

INSERT INTO TB_AGG_NULL_TEST (NUM) VALUES (NULL);
INSERT INTO TB_AGG_NULL_TEST (NUM) VALUES (10);
INSERT INTO TB_AGG_NULL_TEST (NUM) VALUES (20);
INSERT INTO TB_AGG_NULL_TEST (NUM) VALUES (30);
INSERT INTO TB_AGG_NULL_TEST (NUM) VALUES (40);

COMMIT;

--코드 5-75 집계 함수 이용
SELECT SUM(NUM) AS "NUM의합계"
     , AVG(NUM) AS "NUM의평균"
     , MAX(NUM) AS "NUM의최대"
     , MIN(NUM) AS "NUM의최소"
     , COUNT(NUM) AS "NUM의개수"
  FROM TB_AGG_NULL_TEST
;

--코드 5-76 집계 함수 이용 - COUNT(*)
SELECT SUM(NUM) AS "NUM의합계"
     , AVG(NUM) AS "NUM의평균"
     , MAX(NUM) AS "NUM의최대"
     , MIN(NUM) AS "NUM의최소"
     , COUNT(*) AS "NUM의개수_COUNT(*)"
  FROM TB_AGG_NULL_TEST
;

