--코드 5-77 ORDER BY절의 사용 - 오름차순 정렬
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , A.INDUTY_CL_SE_CD
     , NVL(A.UPPER_INDUTY_CL_CD, '(Null)') AS UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL A
 WHERE A.INDUTY_CL_SE_CD = 'ICS001' --대
ORDER BY A.INDUTY_CL_CD
;

--코드 5-78 ORDER BY절의 사용 - 내림차순 정렬
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , A.INDUTY_CL_SE_CD
     , NVL(A.UPPER_INDUTY_CL_CD, '(Null)') AS UPPER_INDUTY_CL_CD
  FROM TB_INDUTY_CL A
 WHERE A.INDUTY_CL_SE_CD = 'ICS001' --대
ORDER BY A.INDUTY_CL_CD DESC
;

--코드 5-79 NULL이 존재하는 칼럼의 역순 정렬
SELECT A.INDUTY_CL_CD AS "업종분류코드"
     , A.INDUTY_CL_NM AS "업종분류명"
     , A.INDUTY_CL_SE_CD AS "업종분류구분코드"
     , NVL(A.UPPER_INDUTY_CL_CD, '(NULL)') AS "상위업종분류코드"
  FROM TB_INDUTY_CL A
 WHERE A.INDUTY_CL_CD LIKE 'Q%'
   AND A.INDUTY_CL_NM LIKE '%음식%'
ORDER BY A.UPPER_INDUTY_CL_CD DESC
;

--코드 5-80 SELECT문에 존재하지 않는 칼럼 기준으로 정렬
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.LN_NM = '9호선'
ORDER BY A.STATN_NM
;

--코드 5-81 지하철역번호 기준 역명 조회
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.SUBWAY_STATN_NO = '000607'
;

--코드 5-82 인구 테이블 조회
SELECT A.AGRDE_SE_CD
     , SUM(A.POPLTN_CNT) AS SUM_POPLTN_CNT
  FROM TB_POPLTN A
 WHERE A.STD_YM = '202010' --2020년 10월 기준
   AND A.POPLTN_SE_CD IN ('M', 'F') --'남', '여'
GROUP BY A.AGRDE_SE_CD
ORDER BY SUM(A.POPLTN_CNT) DESC
;

--코드 5-83 GROUP BY + ORDER BY문에서 ORDER BY절에 기재한 칼럼이 SELECT절 혹은 GROUP BY절에 없는 경우
SELECT A.AGRDE_SE_CD
     , SUM(A.POPLTN_CNT) AS SUM_POPLTN_CNT
  FROM TB_POPLTN A
 WHERE A.STD_YM = '202010' --2020년 10월 기준
   AND A.POPLTN_SE_CD IN ('M', 'F') --'남', '여'
GROUP BY A.AGRDE_SE_CD
ORDER BY A.POPLTN_SE_CD DESC
;

--코드 5-84 10건의 행만을 출력하는 SELECT문
SELECT A.BSSH_NO
     , A.CMPNM_NM
     , A.BHF_NM
     , A.LNM_ADRES
     , A.LO
     , A.LA
  FROM TB_BSSH A
 WHERE ROWNUM <= 10
ORDER BY A.LO
;

--코드 5-85 전체 데이터의 정렬 결과 중에서 상위 10건만 출력하기 - 제대로 된 부분 범위 처리
SELECT A.BSSH_NO
     , A.CMPNM_NM
     , A.BHF_NM
     , A.LNM_ADRES
     , A.LO
     , A.LA
  FROM
     (
       SELECT A.BSSH_NO
            , A.CMPNM_NM
            , A.BHF_NM
            , A.LNM_ADRES
            , A.LO
            , A.LA
         FROM TB_BSSH A
       ORDER BY A.LO
     ) A
WHERE ROWNUM <= 10
;