--코드 8-47 NATURAL JOIN을 이용한 SELECT문
SELECT ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A NATURAL JOIN TB_ADSTRD B
 WHERE ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;


--코드 8-48 NATURAL JOIN SQL문 - 문법 에러
SELECT A.ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A NATURAL JOIN TB_ADSTRD B
 WHERE A.ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-49 INNER JOIN SQL문
SELECT A.ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                           ON (A.ADSTRD_CD = B.ADSTRD_CD)
 WHERE A.ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-50 INNER JOIN SQL문 - 에러 발생
SELECT ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                           ON (ADSTRD_CD = ADSTRD_CD)
 WHERE ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-51 INNER JOIN SQL문 - ORDER BY
SELECT
       A.ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                           ON (A.ADSTRD_CD = B.ADSTRD_CD)
 WHERE A.ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
 ORDER BY ADSTRD_CD
;

--코드 8-52 INNER JOIN SQL문 - ORDER BY - 에러 발생
SELECT A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
    ON (A.ADSTRD_CD = B.ADSTRD_CD)
 WHERE A.ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
 ORDER BY ADSTRD_CD
;

--코드 8-53 USING절 사용 - 조인 칼럼에 테이블 앨리어스 안 붙임 - 정상 실행
SELECT ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                        USING (ADSTRD_CD)
 WHERE ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-54 USING절 사용 - 조인 칼럼에 테이블 앨리어스 붙임 - 에러 발생
SELECT A.ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                        USING (ADSTRD_CD)
 WHERE ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-55 USING절 사용 - ORDER BY절 기재 시 앨리어스 안 붙임 - 정상 실행
SELECT ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                        USING (ADSTRD_CD)
 WHERE ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
 ORDER BY ADSTRD_CD
;

--코드 8-56 USING절 사용 - ORDER BY절 기재 시 테이블 앨리어스 붙임 - 에러 발생
SELECT ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                        USING (ADSTRD_CD)
 WHERE ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
 ORDER BY A.ADSTRD_CD
;

--코드 8-57 ON절 사용
SELECT A.ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                           ON (A.ADSTRD_CD = B.ADSTRD_CD)
 WHERE A.ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-58 ON절 사용 - 테이블 앨리어스 사용 안 함
SELECT A.ADSTRD_CD
     , A.STD_YM
     , A.POPLTN_SE_CD
     , A.AGRDE_SE_CD
     , A.POPLTN_CNT
     , B.ADSTRD_NM
  FROM TB_POPLTN A INNER JOIN TB_ADSTRD B
                           ON (ADSTRD_CD = B.ADSTRD_CD)
 WHERE A.ADSTRD_CD = '4128157500' --경기도 고양시 덕양구 삼송동
   AND A.POPLTN_SE_CD IN ('M', 'F')
   AND A.AGRDE_SE_CD IN ('000', '010')
;

--코드 8-59 실습환경 구축
CREATE TABLE TB_CUST_8_6_6
(
  CUST_ID VARCHAR2(20)
, CUST_NM VARCHAR2(50)
, CONSTRAINT PK_TB_CUST_8_6_6 PRIMARY KEY(CUST_ID)
)
;

INSERT INTO TB_CUST_8_6_6 VALUES ('dbmsexpert', '이경오');
INSERT INTO TB_CUST_8_6_6 VALUES ('oraexpert', '최민수');

COMMIT;

CREATE TABLE TB_ORD_8_6_6
(
  ORD_NO CHAR(10)
, ORD_AMT NUMBER(15)
, PRDT_CD CHAR(6)
, CUST_ID VARCHAR2(20)
, CONSTRAINT PK_TB_ORD_8_6_6 PRIMARY KEY(ORD_NO)
)
;

INSERT INTO TB_ORD_8_6_6 VALUES('1000000001', 30000, 'P00001', 'dbmsexpert');
INSERT INTO TB_ORD_8_6_6 VALUES('1000000002', 60000, 'P00002', 'dbmsexpert');

COMMIT;

--코드 8-60 LEFT OUTER JOIN 수행
SELECT A.CUST_ID
     , A.CUST_NM
     , NVL(B.ORD_NO, '[NULL]') AS ORD_NO
     , NVL(B.ORD_AMT, 0) AS ORD_AMT
     , NVL(B.PRDT_CD, '[NULL]') AS PRDT_CD
     , NVL(B.CUST_ID, '[NULL]') AS CUST_ID
  FROM TB_CUST_8_6_6 A LEFT OUTER JOIN TB_ORD_8_6_6 B
                                    ON (A.CUST_ID = B.CUST_ID)
;

